-- static popup dialog definition
StaticPopupDialogs["GDKPD_RESETPOT"] = {
	text="Do you want to save your pot or reset without saving? You can also add a note to the pot.",
	button1=SAVE.." & "..RESET,
	button2=CANCEL,
	button3=RESET,
	hasEditBox=true,
	EditBoxOnEnterPressed=function(self) self:GetParent().button1:Click() end,
	OnAccept=function(self)
		tinsert(GDKPd_PotData.history, {size=GDKPd_PotData.potAmount, date=date(), note=(strlen(self.editBox:GetText()) > 0 and self.editBox:GetText())})
		GDKPd_PotData.potAmount = 0
		GDKPd.status:Update()
	end,
	OnAlt=function(self)
		GDKPd_PotData.potAmount = 0
		GDKPd.status:Update()
	end,
	timeout=0,
}
StaticPopupDialogs["GDKPD_ADDTOPOT"] = {
	text="Enter the amount you want to add to the pot:",
	button1=ADD,
	button2=CANCEL,
	hasEditBox=true,
	OnShow=function(self)
		self.button1:Disable()
	end,
	EditBoxOnEnterPressed=function(self) self:GetParent().button1:Click() end,
	EditBoxOnTextChanged = function(self)
		if strlen(self:GetText()) > 0 then
			self:GetParent().button1:Enable()
		else
			self:GetParent().button1:Disable()
		end
	end,
	OnAccept=function(self)
		GDKPd_PotData.potAmount = (tonumber(self.editBox:GetText()) or 0)+GDKPd_PotData.potAmount
		GDKPd.status:Update()
	end,
	timeout=0,
}
StaticPopupDialogs["GDKPD_REMFROMPOT"] = {
	text="Enter the amount you want to subtract from the pot:",
	button1=REMOVE,
	button2=CANCEL,
	hasEditBox=true,
	OnShow=function(self)
		self.button1:Disable()
	end,
	EditBoxOnEnterPressed=function(self) self:GetParent().button1:Click() end,
	EditBoxOnTextChanged=function(self)
		if strlen(self:GetText()) > 0 then
			self:GetParent().button1:Enable()
		else
			self:GetParent().button1:Disable()
		end
	end,
	OnAccept = function(self)
		GDKPd_PotData.potAmount = math.max(0, GDKPd_PotData.potAmount-(tonumber(self.editBox:GetText()) or 0))
		GDKPd.status:Update()
	end,
	timeout=0,
}
StaticPopupDialogs["GDKPD_AUTOBID"] = {
	text="Enter the maximum amount of money you want to bid on %s:",
	button1=BID,
	button2=CANCEL,
	hasEditBox=true,
	OnShow=function(self)
		self.button1:Disable()
	end,
	EditBoxOnEnterPressed=function(self) self:GetParent().button1:Click() end,
	EditBoxOnTextChanged = function(self)
		if strlen(self:GetText()) > 0 then
			self:GetParent().button1:Enable()
		else
			self:GetParent().button1:Disable()
		end
	end,
	OnAccept=function(self, data)
		data.maxAutoBid = tonumber(self.editBox:GetText())
		if (data.curbidismine == false) and data.maxAutoBid then
			local newBid = data.curbidamount + data.bidIncrement
			if newBid <= data.maxAutoBid then
				SendChatMessage(tostring(newBid),"RAID")
			end
		end
		data.autobid:Hide()
		data.stopautobid:Show()
	end,
	timeout=0,
}
-- popups done, addon start
local function round(num, places)
	return tonumber(string.format("%."..(places or 0).."f",num))
end
GDKPd = CreateFrame("Frame")
local GDKPd = GDKPd
GDKPd.frames = {}
GDKPd.curAuction = {}
GDKPd.auctionList = {}
GDKPd.ignoredLinks = {}
GDKPd:Hide()
GDKPd:SetScript("OnUpdate", function(self, elapsed)
	if not self.curAuction.item then self:Hide() return end
	local curPot = math.floor(self.curAuction.timeRemains/5)
	self.curAuction.timeRemains = self.curAuction.timeRemains-elapsed
	if (curPot ~= math.floor(self.curAuction.timeRemains/5)) and (curPot*5 < self.opt.auctionTimer) and (curPot > 0) then
		SendChatMessage("[GDKPd] "..(curPot*5).." seconds remaining!","RAID")
	end
	if self.curAuction.timeRemains <= 0 then
		self:Hide()
		self:FinishAuction()
	end
end)
local anchor = CreateFrame("Frame", "GDKPAnchor", UIParent)
anchor:EnableMouse(true)
anchor:SetScript("OnMouseDown", function(self)
	self:StartMoving()
end)
anchor:SetMovable(true)
anchor:SetScript("OnMouseUp", function(self)
	self:StopMovingOrSizing()
	GDKPd.opt.point.point, _, GDKPd.opt.point.relative, GDKPd.opt.point.x, GDKPd.opt.point.y = self:GetPoint()
end)
anchor:SetSize(300,60)
anchor:Hide()
anchor.movetx = anchor:CreateTexture()
anchor.movetx:SetAllPoints()
anchor.movetx:SetTexture(0.3,0.3,0.9)
anchor.movetx:SetAlpha(0.5)
anchor.movetx.text = anchor:CreateFontString()
anchor.movetx.text:SetFontObject(GameFontHighlightLarge)
anchor.movetx.text:SetText("GDKPd: Drag to move")
anchor.movetx.text:SetAllPoints()
GDKPd.status = CreateFrame("Frame", "GDKPd_Status", UIParent)
local status = GDKPd.status
status:SetSize(200, 95)
status:Hide()
status:SetBackdrop({
	bgFile="Interface\\DialogFrame\\UI-DialogBox-Background",
	edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border",
	tileSize=32,
	tile=true,
	insets={
		top=12,
		bottom=12,
		right=12,
		left=12,
	},
})
status.header = CreateFrame("Button", nil, status)
status.header:SetNormalTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
status.header:SetSize(133,34)
status.header.text = status.header:CreateFontString()
status.header.text:SetPoint("TOP",0,-7)
status.header.text:SetFont("Fonts\\FRIZQT__.TTF", 8, "")
status.header.text:SetTextColor(1,1,1)
status.header.text:SetText("GDKPd")
status.header:SetMovable(true)
status.header:SetScript("OnMouseDown", function(self)
	self:StartMoving()
end)
status.header:SetScript("OnMouseUp", function(self)
	self:StopMovingOrSizing()
	GDKPd.opt.statuspoint.point, _, GDKPd.opt.statuspoint.relative, GDKPd.opt.statuspoint.x, GDKPd.opt.statuspoint.y = self:GetPoint()
end)
status:SetPoint("TOP", status.header, "TOP", 0, -6)
status:SetScript("OnShow", function(self)
	self:UpdateSize()
end)
status.text = status:CreateFontString()
status.text:SetFont("Fonts\\FRIZQT__.TTF", 8, "")
status.text:SetTextColor(1,1,1)
status.text:SetPoint("TOPLEFT", 15, -15)
status.text:SetJustifyH("LEFT")
status.distribute = CreateFrame("Button", nil, status, "UIPanelButtonTemplate")
status.distribute:SetSize(65, 15)
status.distribute:SetPoint("TOPLEFT", status.text, "BOTTOMLEFT", 0, -5)
status.distribute:SetText("Distribute")
status.distribute:SetScript("OnClick", function(self)
	GDKPd:DistributePot()
end)
status.reset = CreateFrame("Button", nil, status, "UIPanelButtonTemplate")
status.reset:SetSize(65, 15)
status.reset:SetPoint("LEFT", status.distribute, "RIGHT")
status.reset:SetText(RESET)
status.reset:SetScript("OnClick", function(self)
	StaticPopup_Show("GDKPD_RESETPOT")
end)
status.add = CreateFrame("Button", nil, status, "UIPanelButtonTemplate")
status.add:SetSize(15,15)
status.add:SetPoint("LEFT", status.reset, "RIGHT",10,0)
status.add:SetText("+")
status.add:SetScript("OnClick", function(self)
	StaticPopup_Show("GDKPD_ADDTOPOT")
end)
status.rem = CreateFrame("Button", nil, status, "UIPanelButtonTemplate")
status.rem:SetSize(15,15)
status.rem:SetPoint("LEFT", status.add, "RIGHT")
status.rem:SetText("-")
status.rem:SetScript("OnClick", function(self)
	StaticPopup_Show("GDKPD_REMFROMPOT")
end)
status.announcetext = status:CreateFontString()
status.announcetext:SetFont("Fonts\\FRIZQT__.TTF", 8, "")
status.announcetext:SetTextColor(1,1,1)
status.announcetext:SetPoint("TOPLEFT", status.distribute, "BOTTOMLEFT", 0, -5)
status.announcetext:SetJustifyH("LEFT")
status.announcetext:SetText("You have looted a monster!\nDo you want GDKPd to announce loot?")
status.announcetext:Hide()
status.announce1 = CreateFrame("Button", nil, status, "UIPanelButtonTemplate")
status.announce1:SetSize(170,15)
status.announce1:SetPoint("TOPLEFT", status.announcetext, "BOTTOMLEFT", 0, -5)
status.announce1:SetText("Announce & auto-auction")
status.announce1:SetScript("OnClick", function(self)
	GDKPd:AnnounceLoot(true)
	status.announcetext:Hide()
	self:Hide()
	status.announce2:Hide()
	status.noannounce:Hide()
	status:UpdateSize()
end)
status.announce1:Hide()
status.announce2 = CreateFrame("Button", nil, status, "UIPanelButtonTemplate")
status.announce2:SetSize(170,15)
status.announce2:SetPoint("TOPLEFT", status.announce1, "BOTTOMLEFT", 0, -5)
status.announce2:SetText("Announce loot")
status.announce2:SetScript("OnClick", function(self)
	GDKPd:AnnounceLoot(true)
	status.announcetext:Hide()
	status.announce1:Hide()
	self:Hide()
	status.noannounce:Hide()
	status:UpdateSize()
end)
status.announce2:Hide()
status.noannounce = CreateFrame("Button", nil, status, "UIPanelButtonTemplate")
status.noannounce:SetSize(170,15)
status.noannounce:SetPoint("TOPLEFT", status.announce2, "BOTTOMLEFT", 0, -5)
status.noannounce:SetText("Do not announce")
status.noannounce:SetScript("OnClick", function(self)
	status.announcetext:Hide()
	status.announce1:Hide()
	status.announce2:Hide()
	self:Hide()
	status:UpdateSize()
end)
status.noannounce:Hide()
function status:UpdateSize()
	local height = 50
	height = height+status.text:GetHeight()
	if status.announcetext:IsShown() then
		height=height+status.announcetext:GetHeight()+5
	end
	if status.announce1:IsShown() then
		height=height+20
	end
	if status.announce2:IsShown() then
		height=height+20
	end
	if status.noannounce:IsShown() then
		height=height+20
	end
	self:SetHeight(height)
end
function status:Update()
	self.text:SetText(("Pot size: %d|cffffd100g|r"):format(GDKPd_PotData.potAmount or 0))
	self:UpdateSize()
end
function GDKPd:SetMovable(movable)
	if movable then
		anchor:EnableMouse(true)
		anchor:Show()
	else
		anchor:EnableMouse(false)
		anchor:Hide()
	end
end
function GDKPd:FetchFrameFromLink(itemLink)
	for num, frame in ipairs(GDKPd.frames) do
		if (frame.itemlink == itemLink) and frame:IsShown() then
			return frame,num
		end
	end
end
function GDKPd:PlayerIsML(playerName, invert)
	for raidID = (invert and GetNumRaidMembers() or 1), (invert and 1 or GetNumRaidMembers()), (invert and -1 or 1) do
		local name, _, _, _, _,_,_,_,_,_,isML = GetRaidRosterInfo(raidID)
		if (name == playerName) then
			return isML
		end
	end
end
function GDKPd:AnnounceLoot(shouldQueueAuctions)
	if GetNumLootItems() <= 0 then return end
	local lootList = {}
	for numLoot=1, GetNumLootItems() do
		if LootSlotIsItem(numLoot) then
			local tex, item, quantity, quality, isLocked = GetLootSlotInfo(numLoot)
			if quality >= self.opt.minQuality then
				tinsert(lootList, GetLootSlotLink(numLoot))
			end
		end
	end
	local lootString = "[GDKPd] Loot dropped: "
	for _, link in ipairs(lootList) do
		if strlen(lootString)+strlen(link)+2 > 255 then
			SendChatMessage(lootString,"RAID")
			lootString=link
		else
			lootString=lootString..", "..link
		end
	end
	SendChatMessage(lootString, "RAID")
	for _, item in ipairs(lootList) do
		SendAddonMessage("GDKPd_Start", item, "RAID")
		if shouldQueueAuctions then
			GDKPd:QueueAuction(item, self.opt.startBid, self.opt.increment)
		end
	end
end
function GDKPd:QueueAuction(item, minbid, increment)
	if not GDKPd.curAuction.item then
		GDKPd:AuctionOffItem(item, minbid, increment)
	else
		tinsert(GDKPd.auctionList,{item,minbid,increment})
	end
end
function GDKPd:AuctionOffItem(item, minbid, increment)
	if GDKPd.curAuction.item then return end
	SendChatMessage(("[GDKPd] Bidding starts on %s. Please bid in raid chat, starting bid %d gold, minimum increment %d gold."):format(item,minbid,increment), "RAID")
	GDKPd.curAuction.item = item
	GDKPd.curAuction.curBid = (minbid-increment)
	GDKPd.curAuction.increment = increment
	GDKPd.curAuction.bidders = {}
	GDKPd.curAuction.timeRemains = self.opt.auctionTimer
	GDKPd:Show()
end
function GDKPd:FinishAuction()
	table.sort(self.curAuction.bidders, function(a,b) return a.bidAmount > b.bidAmount end)
	--SendChatMessage(("Auction finished. Winner: %s. %d gold to pot. < TEMP > < ADD SECOND/THIRD SHARE OPTIONS LATER>"):format(self.curAuction.bidders[1].bidderName, self.curAuction.bidders[1].bidAmount),"RAID")
	if self.curAuction.bidders[1] then
		local totalAmount = self.curAuction.bidders[1].bidAmount
		local remAmount = totalAmount
		local paymentString = "%d to pot"
		if self.opt.shareSecondEnable and self.curAuction.bidders[2] then
			local secondShare = round(totalAmount*self.opt.shareSecondAmount)
			remAmount = remAmount-secondShare
			paymentString = paymentString..", "..secondShare.." to "..self.curAuction.bidders[2].bidderName
		end
		if self.opt.shareThirdEnable and self.curAuction.bidders[3] then
			local thirdShare = round(totalAmount*self.opt.shareThirdAmount)
			remAmount = remAmount-thirdShare
			paymentString = paymentString..", "..thirdShare.." to "..self.curAuction.bidders[3].bidderName
		end
		paymentString = paymentString:format(remAmount)
		SendChatMessage(("Auction finished. Winner: %s. %s."):format(self.curAuction.bidders[1].bidderName, paymentString),"RAID")
		GDKPd_PotData.potAmount = (GDKPd_PotData.potAmount or 0)+remAmount
		self.status:Update()
	else
		SendChatMessage("Auction finished. No bids recieved.","RAID")
	end
	table.wipe(self.curAuction)
	if self.auctionList[1] then
		self:AuctionOffItem(unpack(self.auctionList[1]))
		tremove(self.auctionList,1)
	end
end
function GDKPd:DistributePot()
	local numraid = GetRealNumRaidMembers()
	if not (numraid > 0) then return end
	SendChatMessage(("[GDKPd] Distributing pot. Pot size: %d gold. Players in raid: %d. Pot share per player: %d gold."):format((GDKPd_PotData.potAmount or 0), numraid, (GDKPd_PotData.potAmount or 0)/numraid),"RAID")
end
function GDKPd:GetUnoccupiedFrame()
	local c = 1
	while GDKPd.frames[c] do
		if not GDKPd.frames[c]:IsShown() then
			GDKPd.frames[c].hide:Disable()
			GDKPd.frames[c].autobid:Disable()
			GDKPd.frames[c]:EnableMouse(false)
			GDKPd.frames[c].itemlink = nil
			GDKPd.frames[c].maxAutoBid = nil
			GDKPd.frames[c].curbidamount = nil
			GDKPd.frames[c].curbidismine = nil
			GDKPd.frames[c].bidIncrement = nil
			GDKPd.frames[c].autobid:Show()
			GDKPd.frames[c].stopautobid:Hide()
			GDKPd.frames[c].curbid:Hide()
			return GDKPd.frames[c]
		end
		c=c+1
	end
	local f = CreateFrame("Frame", "GDKPdBidFrame"..c, UIParent)
	f:SetSize(300, 60)
	f:SetBackdrop({
		bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
		tileSize=16,
		edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
		tile=true,
		edgeSize=16,
		insets={top=5,bottom=5,left=5,right=5},
	})
	f:SetPoint("TOPLEFT", anchor, "TOPLEFT", 0, (-60)*(c-1))
	f:Hide()
	f.icon = f:CreateTexture()
	f.icon:SetSize(40,40)
	f.icon:SetTexture(1,1,1)
	f.icon:SetPoint("TOPLEFT", 10, -10)
	f.itemstring = f:CreateFontString()
	f.itemstring:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
	f.itemstring:SetTextColor(1,1,1)
	f.itemstring:SetText("This is an item link!")
	f.itemstring:SetPoint("TOPLEFT", f.icon, "TOPRIGHT", 5, 0)
	f.curbid = f:CreateFontString()
	f.curbid:SetFont("Fonts\\FRIZQT__.TTF", 10, "")
	f.curbid:SetTextColor(1,1,1)
	f.curbid:SetText("Current bid: 13|cffffd100g|r")
	f.curbid:SetPoint("TOPLEFT", f.itemstring, "BOTTOMLEFT", 0, -5)
	f.curbid:Hide()
	f.highestbid = f:CreateFontString()
	f.highestbid:SetFont("Fonts\\FRIZQT__.TTF", 10, "OUTLINE")
	f.highestbid:SetTextColor(0.8,0,0)
	f.highestbid:SetPoint("TOPLEFT", f.curbid, "BOTTOMLEFT", 0, -5)
	f.highestbid:SetText("You are the top bidder!")
	f.autobid = CreateFrame("Button", nil, f, "UIPanelButtonTemplate")
	f.autobid:SetText("Auto bid")
	f.autobid:SetSize(70, 16)
	f.autobid:SetScript("OnClick", function(self)
		StaticPopup_Show("GDKPD_AUTOBID", f.itemlink).data=f
		f.hide:Disable()
	end)
	f.autobid:SetPoint("TOPRIGHT", -10, -10)
	f.stopautobid = CreateFrame("Button", nil, f, "UIPanelButtonTemplate")
	f.stopautobid:SetText("Stop bid")
	f.stopautobid:SetAllPoints(f.autobid)
	f.stopautobid:Hide()
	f.stopautobid:SetScript("OnClick", function(self)
		self:Hide()
		f.maxAutoBid = nil
		f.autobid:Show()
		f.hide:Enable()
	end)
	f.hide = CreateFrame("Button", nil, f, "UIPanelButtonTemplate")
	f.hide:SetText("Hide")
	f.hide:SetSize(70,16)
	f.hide:SetPoint("TOP", f.autobid, "BOTTOM", 0, -8)
	f.hide:SetScript("OnClick", function(self)
		GDKPd.ignoredLinks[f.itemlink] = true
		f:Hide()
	end)
	f.autobid:Disable()
	f.hide:Disable()
	function f:SetItem(itemlink)
		self.icon:SetTexture((select(10,GetItemInfo(itemlink))))
		self.itemstring:SetText(itemlink)
		self:EnableMouse(true)
		self.autobid:Enable()
		self.hide:Enable()
		self.highestbid:Hide()
		self.itemlink = itemlink
	end
	function f:SetCurBid(goldAmount, isMine, isInitial)
		self.curbid:SetText((isInitial and "Minimum bid: " or "Current bid: ")..goldAmount.."|cffffd100g|r")
		self.highestbid[isMine and "Show" or "Hide"](self.highestbid)
		self.curbidamount = goldAmount-(isInitial and self.bidIncrement or 0)
		self.curbidismine = not not isMine
		self.curbid:Show()
	end
	f:SetScript("OnEnter", function(self)
		GameTooltip:ClearAllPoints()
		GameTooltip:ClearLines()
		GameTooltip:SetOwner(self, "ANCHOR_NONE")
		GameTooltip:SetHyperlink(self.itemlink)
		GameTooltip:SetPoint("RIGHT", self, "LEFT")
		GameTooltip:Show()
	end)
	f:SetScript("OnLeave", function() GameTooltip:Hide() end)
	GDKPd.frames[c] = f
	return f
end

local defaults={profile={
	point={
		point="CENTER",
		relative="CENTER",
		x=0,
		y=0,
	},
	statuspoint={
		point="CENTER",
		relative="CENTER",
		x=0,
		y=0,
	},
	shareSecondEnable=false,
	shareSecondAmount=0.33,
	shareThirdEnable=false,
	shareThirdAmount=0.11,
	auctionTimer=15,
	movable=true,
	startBid=300,
	increment=100,
	minQuality=3,
}}

GDKPd.options={
	type="group",
	args={
		lock={
			type="toggle",
			name="Lock",
			desc="Prevent dragging and hide anchor",
			get=function() return not GDKPd.opt.movable end,
			set=function(info, value) GDKPd.opt.movable = not value GDKPd:SetMovable(not value) end,
		},
		behaviour={
			type="group",
			name="Behaviour options",
			args={
				startBid={
					type="range",
					name="Starting bid",
					min=0,
					max=100000,
					softMax=1000,
					softMin=0,
					step=1,
					get=function() return GDKPd.opt.startBid end,
					set=function(info, value) GDKPd.opt.startBid = value end,
					order=1,
				},
				minIncrement={
					type="range",
					name="Minimum increment",
					min=1,
					max=100000,
					softMax=1000,
					softMin=10,
					step=1,
					get=function() return GDKPd.opt.increment end,
					set=function(info, value) GDKPd.opt.increment = value end,
					order=2,
				},
				secondShare={
					dialogInline=true,
					name="Second bidder share",
					order=3,
					type="group",
					args={
						isEnabled={
							order=1,
							type="toggle",
							name="Enable",
							set=function(info,value) GDKPd.opt.shareSecondEnable = value end,
							get=function() return GDKPd.opt.shareSecondEnable end,
						},
						shareAmount={
							order=2,
							type="range",
							name="Amount",
							min=0.01,
							max=0.99,
							isPercent=true,
							set=function(info, value) GDKPd.opt.shareSecondAmount = value end,
							get=function() return GDKPd.opt.shareSecondAmount end,
						},
					},
				},
				thirdShare={
					dialogInline=true,
					name="Third bidder share",
					order=4,
					type="group",
					args={
						isEnabled={
							order=1,
							type="toggle",
							name="Enable",
							set=function(info,value) GDKPd.opt.shareThirdEnable = value end,
							get=function() return GDKPd.opt.shareThirdEnable end,
						},
						shareAmount={
							order=2,
							type="range",
							name="Amount",
							min=0.01,
							max=0.99,
							isPercent=true,
							set=function(info, value) GDKPd.opt.shareThirdAmount = value end,
							get=function() return GDKPd.opt.shareThirdAmount end,
						},
					},
				},
				minQuality={
					type="select",
					values=function()
						local vtab={}
						for key, tab in pairs(ITEM_QUALITY_COLORS) do
							if _G["ITEM_QUALITY"..key.."_DESC"] then
								vtab[key] = tab.hex.._G["ITEM_QUALITY"..key.."_DESC"].."|r"
							end
						end
						return vtab
					end,
					name="Minimum quality",
					set=function(info, value) GDKPd.opt.minQuality = value end,
					get=function() return GDKPd.opt.minQuality end,
					order=5,
				},
				auctionTimer={
					type="range",
					softMin=5,
					softMax=30,
					order=6,
					name="Auction timeout",
					desc="The amount of seconds that have to pass after a bid before the auction is closed",
					set=function(info, value) GDKPd.opt.auctionTimer = value end,
					get=function() return GDKPd.opt.auctionTimer end,
				},
			},
			order=1,
		},
	},
}

function GDKPd:OnProfileEnable()
	self.opt = self.db.profile
end

GDKPd:SetScript("OnEvent", function(self, event, ...)
	local arg = {...}
	if event == "ADDON_LOADED" and arg[1] == "GDKPd" then
		self:UnregisterEvent("ADDON_LOADED")
		GDKPd_PotData = GDKPd_PotData or {history={},potAmount=0}
		self.status:Update()
		self.db = LibStub("AceDB-3.0"):New("GDKPd_DB", defaults or {})
		self.db.RegisterCallback(self,"OnProfileChanged","OnProfileEnable")
		self.db.RegisterCallback(self,"OnProfileCopied","OnProfileEnable")
		self.db.RegisterCallback(self,"OnProfileReset","OnProfileEnable")
		self.opt = self.db.profile
		self.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
		self.options.args.profiles.order = -1
		LibStub("AceConfig-3.0"):RegisterOptionsTable("GDKPd", self.options)
		SlashCmdList["GDKPD"] = function(input)
			local cmd, link = input:match("(%S+)%s+(|c........|Hitem:.+|r)")
			if (cmd and cmd == "auction") and link and self:PlayerIsML((UnitName("player")),true) then
				self:QueueAuction(link, self.opt.startBid, self.opt.increment)
			elseif input:lower() == "ver" then
				print("GDKPd version %s. Packaged %s."):format("beta-3","2010-08-13T20:34:08Z")
			else
				LibStub("AceConfigDialog-3.0"):Open("GDKPd")
			end
		end
		SLASH_GDKPD1 = "/gdkpd"
		SLASH_GDKPD2 = "/gdkp"
		anchor:SetPoint(self.opt.point.point, UIParent, self.opt.point.relative, self.opt.point.x, self.opt.point.y)
		self:SetMovable(self.opt.movable)
		self.status.header:SetPoint(self.opt.statuspoint.point, UIParent, self.opt.statuspoint.relative, self.opt.statuspoint.x, self.opt.statuspoint.y)
	end
	if (event == "CHAT_MSG_RAID") or (event == "CHAT_MSG_RAID_LEADER") then
		local msg = arg[1]
		local itemLink, minBid, bidIncrement = string.match(msg, "%[GDKPd%] Bidding starts on (|c........|Hitem:.+|r). Please bid in raid chat, starting bid (%d+) gold, minimum increment (%d+) gold.")
		if itemLink and self:PlayerIsML(arg[2], false) then
			if not self.ignoredLinks[itemLink] then
				local f = GDKPd:FetchFrameFromLink(itemLink)
				if not f then
					f = self:GetUnoccupiedFrame()
					f:SetItem(itemLink)
					f:Show()
				end
				self.InProgressBidFrame = f
				f.bidIncrement = bidIncrement
				f:SetCurBid(minBid, false, true)
				if f.maxAutoBid then
					local newBid = minBid+bidIncrement
					if newBid < f.maxAutoBid then
						SendChatMessage(tostring(newBid),"RAID")
					end
				end
			else
				self.ignoredLinks[itemLink] = nil
			end
		end
		if self.curAuction.item and msg:find("%d+") == 1 then
			local newBid = tonumber(msg:sub(msg:find("%d+")))
			if (self.curAuction.curBid + self.curAuction.increment) <= newBid then
				GDKPd.curAuction.curBid = newBid
				if GDKPd.curAuction.bidders[arg[2]] then
					GDKPd.curAuction.bidders[GDKPd.curAuction.bidders[arg[2]]].bidAmount = newBid
				else
					tinsert(GDKPd.curAuction.bidders, {bidAmount=newBid, bidderName=arg[2]})
					GDKPd.curAuction.bidders[arg[2]] = #GDKPd.curAuction.bidders
				end
				SendChatMessage(("[GDKPd] New highest bidder: %s (%d gold)"):format(arg[2], newBid),"RAID")
				self.curAuction.timeRemains = self.opt.auctionTimer
			end
		end
		local bidderName, newBid = string.match(msg, "%[GDKPd%] New highest bidder: (%S+) %((%d+) gold%)")
		if bidderName and self.InProgressBidFrame then
			local isSelf = bidderName == (UnitName("player"))
			self.InProgressBidFrame:SetCurBid(newBid, isSelf)
			if not isSelf then
				if self.InProgressBidFrame.maxAutoBid then
					local myNewBid = newBid+self.InProgressBidFrame.bidIncrement
					if myNewBid <= self.InProgressBidFrame.maxAutoBid then
						SendChatMessage(tostring(myNewBid),"RAID")
					end
				end
			end
		end
		if msg:find("Auction finished.") and GDKPd:PlayerIsML(arg[2],false) and self.InProgressBidFrame then
			self.InProgressBidFrame:Hide()
			self.InProgressBidFrame = nil
		end
	end
	if (event == "CHAT_MSG_ADDON") then
		if arg[1] == "GDKPd_Start" and self:PlayerIsML(arg[4],false) then
			local f = self:GetUnoccupiedFrame()
			f:SetItem(arg[2])
			f:Show()
		end
	end
	if (event == "LOOT_CLOSED") then
		self.status.announcetext:Hide()
		self.status.announce1:Hide()
		self.status.announce2:Hide()
		self.status.noannounce:Hide()
		self.status:UpdateSize()
	end
	if (event == "LOOT_OPENED") and self:PlayerIsML((UnitName("player")), true) then
		self.status.announcetext:Show()
		self.status.announce1:Show()
		self.status.announce2:Show()
		self.status.noannounce:Show()
		self.status:UpdateSize()
	end
	if event == "RAID_ROSTER_UPDATE" then
		if self:PlayerIsML((UnitName("player")),true) then
			self.status:Show()
		else
			self.status:Hide()
		end
	end
end)
GDKPd:RegisterEvent("ADDON_LOADED")
GDKPd:RegisterEvent("CHAT_MSG_RAID")
GDKPd:RegisterEvent("CHAT_MSG_RAID_LEADER")
GDKPd:RegisterEvent("LOOT_OPENED")
GDKPd:RegisterEvent("LOOT_CLOSED")
GDKPd:RegisterEvent("RAID_ROSTER_UPDATE")
GDKPd:RegisterEvent("CHAT_MSG_ADDON")
--[===[@debug@
SlashCmdList["LINKBREAK"] = function(input)
	print((string.gsub(input, "\124","\124\124")))
end
SLASH_LINKBREAK1= "/linkbreak"
--@end-debug@]===]